(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("vue"));
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["vue-rxdb-hasura"] = factory(require("vue"));
	else
		root["vue-rxdb-hasura"] = factory(root["Vue"]);
})((typeof self !== 'undefined' ? self : this), function(__WEBPACK_EXTERNAL_MODULE__8bbf__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/ 		var executeModules = data[2];
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(Object.prototype.hasOwnProperty.call(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 		// add entry modules from loaded chunk to deferred list
/******/ 		deferredModules.push.apply(deferredModules, executeModules || []);
/******/
/******/ 		// run deferred modules when all chunks ready
/******/ 		return checkDeferredModules();
/******/ 	};
/******/ 	function checkDeferredModules() {
/******/ 		var result;
/******/ 		for(var i = 0; i < deferredModules.length; i++) {
/******/ 			var deferredModule = deferredModules[i];
/******/ 			var fulfilled = true;
/******/ 			for(var j = 1; j < deferredModule.length; j++) {
/******/ 				var depId = deferredModule[j];
/******/ 				if(installedChunks[depId] !== 0) fulfilled = false;
/******/ 			}
/******/ 			if(fulfilled) {
/******/ 				deferredModules.splice(i--, 1);
/******/ 				result = __webpack_require__(__webpack_require__.s = deferredModule[0]);
/******/ 			}
/******/ 		}
/******/
/******/ 		return result;
/******/ 	}
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		34: 0
/******/ 	};
/******/
/******/ 	var deferredModules = [];
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	var jsonpArray = (typeof self !== 'undefined' ? self : this)["webpackJsonpvue_rxdb_hasura"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpvue_rxdb_hasura"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// add entry module to deferred list
/******/ 	deferredModules.push(["dd63",15,35,18,9,33,37,13,39,4,10,19,40,16,21,30,29,2,49,45,6,50,41,27,7,38,11,48,28,32,5,20,17,47,22,3,1,31,25,0,44,43,42,23,12,24,36,14,46,26,8]);
/******/ 	// run deferred modules when ready
/******/ 	return checkDeferredModules();
/******/ })
/************************************************************************/
/******/ ({

/***/ "3a0b":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d86f");

__webpack_require__("9531");

__webpack_require__("ef14");

__webpack_require__("e416");

__webpack_require__("868d");

__webpack_require__("8f84");

__webpack_require__("52f9");

__webpack_require__("6559");

__webpack_require__("f8a5");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("2aa5");

__webpack_require__("f3b8");

__webpack_require__("918c");

var _slicedToArray = __webpack_require__("75d5");

__webpack_require__("df26");

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addModule = void 0;

var rxdb_hasura_1 = __webpack_require__("9c85");

var immutable = __importStar(__webpack_require__("162b"));

var state = function state() {
  return {
    forms: {}
  };
};

var addModule = function addModule(db, store) {
  store.registerModule('rxdb', {
    namespaced: true,
    state: state,
    getters: {
      form: function form(state) {
        return state.forms;
      },
      getField: function getField(state) {
        return function (document, field) {
          return document && immutable.get(state.forms, "".concat(document.collection.name, ".").concat(document.primary, ".").concat(field));
        };
      }
    },
    actions: {
      save: function save(_ref) {
        var state = _ref.state,
            commit = _ref.commit;
        return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
          var _i, _Object$entries, _Object$entries$_i, collectionName, documents, collection, _loop, _i2, _Object$entries2;

          return regeneratorRuntime.wrap(function _callee$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (db.value) {
                    _context2.next = 2;
                    break;
                  }

                  return _context2.abrupt("return");

                case 2:
                  _i = 0, _Object$entries = Object.entries(state.forms);

                case 3:
                  if (!(_i < _Object$entries.length)) {
                    _context2.next = 16;
                    break;
                  }

                  _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2), collectionName = _Object$entries$_i[0], documents = _Object$entries$_i[1];
                  collection = db.value[collectionName];
                  _loop = /*#__PURE__*/regeneratorRuntime.mark(function _loop() {
                    var _Object$entries2$_i, documentId, formValues, document, changed, values;

                    return regeneratorRuntime.wrap(function _loop$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _Object$entries2$_i = _slicedToArray(_Object$entries2[_i2], 2), documentId = _Object$entries2$_i[0], formValues = _Object$entries2$_i[1];
                            _context.next = 3;
                            return collection.findOne(documentId).exec();

                          case 3:
                            document = _context.sent;

                            if (!document) {
                              _context.next = 20;
                              break;
                            }

                            changed = Object.entries(formValues).some(function (_ref2) {
                              var _ref3 = _slicedToArray(_ref2, 2),
                                  key = _ref3[0],
                                  value = _ref3[1];

                              return document.get(key) !== value;
                            });

                            if (!changed) {
                              _context.next = 17;
                              break;
                            }

                            _context.prev = 7;
                            _context.next = 10;
                            return document.atomicPatch(formValues);

                          case 10:
                            _context.next = 15;
                            break;

                          case 12:
                            _context.prev = 12;
                            _context.t0 = _context["catch"](7);
                            console.error(_context.t0);

                          case 15:
                            _context.next = 18;
                            break;

                          case 17:
                            console.info('No document changed');

                          case 18:
                            _context.next = 24;
                            break;

                          case 20:
                            values = collection.newDocument(formValues);
                            values.set(collection.schema.primaryPath, documentId);
                            _context.next = 24;
                            return values.save();

                          case 24:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _loop, null, [[7, 12]]);
                  });
                  _i2 = 0, _Object$entries2 = Object.entries(documents);

                case 8:
                  if (!(_i2 < _Object$entries2.length)) {
                    _context2.next = 13;
                    break;
                  }

                  return _context2.delegateYield(_loop(), "t0", 10);

                case 10:
                  _i2++;
                  _context2.next = 8;
                  break;

                case 13:
                  _i++;
                  _context2.next = 3;
                  break;

                case 16:
                  commit('reset');

                case 17:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee);
        }));
      }
    },
    mutations: {
      setField: function setField(state, _ref4) {
        var document = _ref4.document,
            field = _ref4.field,
            value = _ref4.value;
        var collection = document.collection;
        state.forms = immutable.set(state.forms, "".concat(collection.name, ".").concat(document.primary, ".").concat(field), rxdb_hasura_1.castValue(document, field, value));
      },
      resetField: function resetField(state, _ref5) {
        var document = _ref5.document,
            field = _ref5.field;
        var collection = document.collection;
        state.forms = deletePath(state.forms, [collection.name, document.primary, field]);
      },
      reset: function reset(state) {
        state.forms = {};
      }
    },
    modules: {}
  });
};

exports.addModule = addModule;

var deletePath = function deletePath(object, path) {
  var result = immutable.del(object, path.join('.'));
  path.pop();
  if (path.length && !Object.keys(immutable.get(result, path.join('.'))).length) return deletePath(object, path);else return result;
};

/***/ }),

/***/ "479d":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d6de");

__webpack_require__("8d0f");

__webpack_require__("8f0b");

__webpack_require__("9531");

__webpack_require__("868d");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("fa8c");

__webpack_require__("918c");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createVueRxDBHasuraPlugin = exports.DefaultRxDBKey = void 0;

__webpack_require__("2a83");

__webpack_require__("9669");

__webpack_require__("7735");

__webpack_require__("014c");

var rxdb_hasura_1 = __webpack_require__("9c85");

var button_1 = __importDefault(__webpack_require__("eb41"));

var calendar_1 = __importDefault(__webpack_require__("fd4f"));

var checkbox_1 = __importDefault(__webpack_require__("ff29"));

var column_1 = __importDefault(__webpack_require__("6b4d"));

var columngroup_1 = __importDefault(__webpack_require__("bb4f"));

var config_1 = __importDefault(__webpack_require__("5abe"));

var datatable_1 = __importDefault(__webpack_require__("4620"));

var dataview_1 = __importDefault(__webpack_require__("4631"));

var dialog_1 = __importDefault(__webpack_require__("363b"));

var dropdown_1 = __importDefault(__webpack_require__("4c2a"));

var inputnumber_1 = __importDefault(__webpack_require__("42c1"));

var inputtext_1 = __importDefault(__webpack_require__("d311"));

var vue_1 = __webpack_require__("8bbf");

var store_1 = __webpack_require__("3a0b");

exports.DefaultRxDBKey = Symbol();

var createVueRxDBHasuraPlugin = function createVueRxDBHasuraPlugin(_ref) {
  var name = _ref.name,
      endpoint = _ref.endpoint,
      hbp = _ref.hbp,
      store = _ref.store;
  var db = vue_1.ref();

  var install = function install(app, injectKey) {
    return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var components;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              rxdb_hasura_1.createRxHasura(name, endpoint).then(function (value) {
                db.value = value;
                value.setStatus(!!hbp.auth.isAuthenticated(), hbp.auth.getJWTToken());
                hbp.auth.onAuthStateChanged(function (status) {
                  return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            value.setStatus(status, hbp.auth.getJWTToken());

                          case 1:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));
                });
                hbp.auth.onTokenChanged(function () {
                  value.setJwt(hbp.auth.getJWTToken());
                });
              });
              components = __webpack_require__("ffe0");
              components.keys().forEach(function (filename) {
                var Comp = components(filename)["default"];
                app.component(Comp.name, Comp);
              });
              app.provide(injectKey || exports.DefaultRxDBKey, db);
              store_1.addModule(db, store);
              app.use(config_1["default"]);
              app.component('Button', button_1["default"]);
              app.component('Calendar', calendar_1["default"]);
              app.component('Checkbox', checkbox_1["default"]);
              app.component('Column', column_1["default"]);
              app.component('ColumnGroup', columngroup_1["default"]);
              app.component('DataTable', datatable_1["default"]);
              app.component('Dialog', dialog_1["default"]);
              app.component('Dropdown', dropdown_1["default"]);
              app.component('InputNumber', inputnumber_1["default"]);
              app.component('InputText', inputtext_1["default"]);
              app.component('DataView', dataview_1["default"]);

            case 17:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
  };

  return {
    db: db,
    install: install
  };
};

exports.createVueRxDBHasuraPlugin = createVueRxDBHasuraPlugin;

/***/ }),

/***/ "8bbf":
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__8bbf__;

/***/ }),

/***/ "ffb4":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("8f84");

__webpack_require__("52f9");

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __exportStar = this && this.__exportStar || function (m, exports) {
  for (var p in m) {
    if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  }
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DefaultRxDBKey = exports.createVueRxDBHasuraPlugin = void 0;
;
window.global = window;
window.process = {
  env: {
    DEBUG: undefined
  }
};

var plugin_1 = __webpack_require__("479d");

Object.defineProperty(exports, "createVueRxDBHasuraPlugin", {
  enumerable: true,
  get: function get() {
    return plugin_1.createVueRxDBHasuraPlugin;
  }
});
Object.defineProperty(exports, "DefaultRxDBKey", {
  enumerable: true,
  get: function get() {
    return plugin_1.DefaultRxDBKey;
  }
});

__exportStar(__webpack_require__("2746"), exports);

/***/ })

/******/ });
});
//# sourceMappingURL=vue-rxdb-hasura.umd.js.map