((typeof self !== 'undefined' ? self : this)["webpackJsonpvue_rxdb_hasura"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpvue_rxdb_hasura"] || []).push([[15],{

/***/ 0:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ "00bf":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("868d");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createContentReplicator = void 0;

var subscriptions_transport_ws_1 = __webpack_require__("5a34");

var console_1 = __webpack_require__("e41d");

var utils_1 = __webpack_require__("7d01");

var pull_1 = __webpack_require__("62a7");

var push_1 = __webpack_require__("c11e");

var subscribe_1 = __webpack_require__("30f0");

var DEFAULT_BATCH_SIZE = 5;

var createContentReplicator = function createContentReplicator(collection) {
  return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
    var url, db, state, wsSubscription, jwtSubscription, setupGraphQLReplication, setupGraphQLSubscription, start, stop;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            url = collection.database.options.url;
            db = collection.database;

            setupGraphQLReplication = function setupGraphQLReplication() {
              return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                var token, headers, replicationState;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        token = db.jwt$.getValue();
                        headers = token ? {
                          Authorization: "Bearer ".concat(token)
                        } : {};
                        replicationState = collection.syncGraphQL({
                          url: url,
                          headers: headers,
                          push: {
                            batchSize: DEFAULT_BATCH_SIZE,
                            queryBuilder: push_1.pushQueryBuilder(collection),
                            modifier: push_1.pushModifier(collection)
                          },
                          pull: {
                            queryBuilder: pull_1.pullQueryBuilder(collection, DEFAULT_BATCH_SIZE),
                            modifier: pull_1.pullModifier(collection)
                          },
                          live: true,
                          liveInterval: 1000 * 60 * 10,
                          deletedFlag: 'deleted',
                          waitForLeadership: true
                        });
                        replicationState.error$.subscribe(function (err) {
                          console_1.error("replication error on ".concat(collection.name));
                          console_1.errorDir(err.innerErrors);
                        });
                        jwtSubscription = db.jwt$.subscribe(function (token) {
                          console_1.debug("Replicator (".concat(collection.name, "): set token"));
                          var headers = replicationState.headers;
                          if (token) headers.Authorization = "Bearer ".concat(token);else delete headers.Authorization;
                          replicationState.setHeaders(headers);
                        });
                        return _context.abrupt("return", replicationState);

                      case 6:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
            };

            setupGraphQLSubscription = function setupGraphQLSubscription() {
              var wsUrl = utils_1.httpUrlToWebSockeUrl(url);
              var token = db.jwt$.getValue();
              var headers = token ? {
                Authorization: "Bearer ".concat(token)
              } : {};
              var wsClient = new subscriptions_transport_ws_1.SubscriptionClient(wsUrl, {
                reconnect: true,
                connectionParams: {
                  headers: headers
                },
                timeout: 1000 * 60,
                reconnectionAttempts: 10000,
                inactivityTimeout: 10 * 1000,
                lazy: true
              });
              var ret = wsClient.request({
                query: subscribe_1.subscriptionQuery(collection)
              });
              ret.subscribe({
                next: function next(data) {
                  console_1.info("subscription on ".concat(collection.name, " emitted"), data);
                  state === null || state === void 0 ? void 0 : state.run();
                },
                error: function error(_error) {
                  console_1.warn("subscription ".concat(collection.name, " error"), _error);
                }
              });
              return wsClient;
            };

            start = function start() {
              return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return setupGraphQLReplication();

                      case 2:
                        state = _context2.sent;
                        wsSubscription = setupGraphQLSubscription();

                      case 4:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));
            };

            stop = function stop() {
              return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return state === null || state === void 0 ? void 0 : state.cancel();

                      case 2:
                        jwtSubscription === null || jwtSubscription === void 0 ? void 0 : jwtSubscription.unsubscribe();
                        wsSubscription === null || wsSubscription === void 0 ? void 0 : wsSubscription.close();

                      case 4:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));
            };

            db.status$.subscribe(function (status) {
              return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        if (!status) {
                          _context4.next = 5;
                          break;
                        }

                        _context4.next = 3;
                        return start();

                      case 3:
                        _context4.next = 7;
                        break;

                      case 5:
                        _context4.next = 7;
                        return stop();

                      case 7:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              }));
            });
            collection.replicator = {
              start: start,
              stop: stop
            };

          case 8:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
};

exports.createContentReplicator = createContentReplicator;

/***/ }),

/***/ "042f":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.contentsCollectionCreator = void 0;

var helpers_1 = __webpack_require__("87b5");

var collection_methods_1 = __webpack_require__("3aaa");

var document_methods_1 = __webpack_require__("0b0f");

var contentsCollectionCreator = function contentsCollectionCreator(metadata) {
  return {
    schema: helpers_1.toJsonSchema(metadata),
    statics: collection_methods_1.collectionMethods,
    methods: document_methods_1.documentMethods,
    options: {
      metadata: metadata
    }
  };
};

exports.contentsCollectionCreator = contentsCollectionCreator;

/***/ }),

/***/ "0b0f":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.documentMethods = void 0;

var rxdb_1 = __webpack_require__("a078");

exports.documentMethods = {
  canEdit: function canEdit(propertyName) {
    var collection = this.collection;
    return rxdb_1.isRxDocument(this) ? collection.canInsert(propertyName) : collection.canUpdate(propertyName);
  },
  canSave: function canSave() {
    return true;
  }
};

/***/ }),

/***/ 1:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ "13cd":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d86f");

__webpack_require__("2d6d");

__webpack_require__("cfce");

__webpack_require__("28eb");

__webpack_require__("e416");

__webpack_require__("52f9");

__webpack_require__("d48b");

var _toConsumableArray = __webpack_require__("4615");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getReverseOneToMany = void 0;

var getReverseOneToMany = function getReverseOneToMany(table, tables) {
  return table.relationships.filter(function (_ref) {
    var rel_type = _ref.rel_type;
    return rel_type === 'object';
  }).reduce(function (aggr, relation) {
    return [].concat(_toConsumableArray(aggr), _toConsumableArray(Object.values(tables).filter(function (curs) {
      return relation.mapping.some(function (m) {
        var _a, _b;

        return ((_a = m.remoteTable) === null || _a === void 0 ? void 0 : _a.table_name) === curs.table_name && ((_b = m.remoteTable) === null || _b === void 0 ? void 0 : _b.table_schema) === curs.table_schema;
      });
    }).map(function (table) {
      return {
        remoteTable: table,
        from: relation
      };
    })));
  }, []).map(function (_ref2) {
    var remoteTable = _ref2.remoteTable,
        from = _ref2.from;
    return remoteTable.relationships.filter(function (rel) {
      return rel.rel_type === 'array' && rel.mapping.some(function (m) {
        var _a, _b;

        return ((_a = m === null || m === void 0 ? void 0 : m.remoteTable) === null || _a === void 0 ? void 0 : _a.table_name) === table.table_name && ((_b = m.remoteTable) === null || _b === void 0 ? void 0 : _b.table_schema) === table.table_schema;
      });
    }).map(function (remote) {
      return {
        remoteTable: remoteTable,
        from: from,
        to: remote
      };
    });
  }).reduce(function (aggr, curr) {
    return [].concat(_toConsumableArray(aggr), _toConsumableArray(curr));
  }, []);
};

exports.getReverseOneToMany = getReverseOneToMany;

/***/ }),

/***/ 2:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ 3:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ "30f0":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d86f");

__webpack_require__("2d6d");

__webpack_require__("ef14");

__webpack_require__("cfce");

__webpack_require__("fbf3");

__webpack_require__("7004");

__webpack_require__("52f9");

var _toConsumableArray = __webpack_require__("4615");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.subscriptionQuery = void 0;

var helpers_1 = __webpack_require__("87b5");

var subscriptionQuery = function subscriptionQuery(collection) {
  var table = collection.metadata;
  var title = helpers_1.metadataName(table);
  var now = new Date(Date.now()).toUTCString();
  var arrayRels = table.relationships.filter(function (rel) {
    return rel.rel_type === 'array';
  }).map(function (rel) {
    return rel.rel_name;
  });
  var fields = [collection.schema.primaryPath, 'updated_at'].concat(_toConsumableArray(arrayRels.map(function (rel) {
    return "".concat(rel, " { id updated_at }\n    ").concat(rel, "_aggregate { aggregate { max { updated_at } count } }");
  }))).join(' ');
  var orConditions = ["{ updated_at: { _gt: \"".concat(now, "\" }}")].concat(_toConsumableArray(arrayRels.map(function (rel) {
    return "{".concat(rel, ": { updated_at: { _gt: \"").concat(now, "\" } } }");
  }))).join('\n');
  return "subscription on".concat(title, " {\n    ").concat(title, " (\n        where: {\n            _or: [").concat(orConditions, "]\n        }\n        order_by: { updated_at: asc }\n    ){ ").concat(fields, " }\n}");
};

exports.subscriptionQuery = subscriptionQuery;

/***/ }),

/***/ "30f8":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});

/***/ }),

/***/ "3aaa":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d6de");

__webpack_require__("8d0f");

__webpack_require__("0df8");

__webpack_require__("841a");

__webpack_require__("cfce");

__webpack_require__("868d");

__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.collectionMethods = void 0;

var config = function config(collection, property) {
  var _a, _b;

  return property ? ((_a = collection.metadata.columns.find(function (_ref) {
    var column_name = _ref.column_name;
    return column_name === property;
  })) === null || _a === void 0 ? void 0 : _a.config) || ((_b = collection.metadata.relationships.find(function (rel) {
    return rel.rel_name === property;
  })) === null || _b === void 0 ? void 0 : _b.config) : collection.metadata.config;
};

exports.collectionMethods = {
  canInsert: function canInsert(fieldName) {
    var _this = this;

    var _a;

    if (fieldName) {
      var property = this.schema.jsonSchema.properties[fieldName];

      if (property === null || property === void 0 ? void 0 : property.ref) {
        var relationship = this.metadata.relationships.find(function (_ref2) {
          var rel_name = _ref2.rel_name;
          return rel_name === fieldName;
        });

        if ((relationship === null || relationship === void 0 ? void 0 : relationship.rel_type) === 'object') {
          var columns = relationship.mapping.map(function (m) {
            var _a;

            return (_a = m.column) === null || _a === void 0 ? void 0 : _a.column_name;
          });
          return columns.every(function (column) {
            return column && _this.canInsert(column);
          });
        } else {
          return false;
        }
      } else {
        var column = this.metadata.columns.find(function (col) {
          return col.column_name === fieldName;
        });
        return !!(column === null || column === void 0 ? void 0 : column.canInsert.length);
      }
    } else {
      return !!((_a = this.metadata.canInsert_aggregate.aggregate) === null || _a === void 0 ? void 0 : _a.count);
    }
  },
  canUpdate: function canUpdate(fieldName) {
    var _this2 = this;

    var _a;

    if (fieldName) {
      var property = this.schema.jsonSchema.properties[fieldName];

      if (property === null || property === void 0 ? void 0 : property.ref) {
        var relationship = this.metadata.relationships.find(function (_ref3) {
          var rel_name = _ref3.rel_name;
          return rel_name === fieldName;
        });

        if ((relationship === null || relationship === void 0 ? void 0 : relationship.rel_type) === 'object') {
          var columns = relationship.mapping.map(function (m) {
            var _a;

            return (_a = m.column) === null || _a === void 0 ? void 0 : _a.column_name;
          });
          return columns.every(function (column) {
            return column && _this2.canUpdate(column);
          });
        } else {
          return false;
        }
      } else {
        var column = this.metadata.columns.find(function (col) {
          return col.column_name === fieldName;
        });
        return !!(column === null || column === void 0 ? void 0 : column.canUpdate.length);
      }
    } else {
      return !!((_a = this.metadata.canUpdate_aggregate.aggregate) === null || _a === void 0 ? void 0 : _a.count);
    }
  },
  title: function title(property) {
    var _a;

    return ((_a = config(this, property)) === null || _a === void 0 ? void 0 : _a.title) || property || this.name;
  },
  description: function description(property) {
    var _a;

    return ((_a = config(this, property)) === null || _a === void 0 ? void 0 : _a.description) || '';
  },
  icon: function icon(property) {
    var _a;

    return ((_a = config(this, property)) === null || _a === void 0 ? void 0 : _a.icon) || '';
  },
  defaultView: function defaultView() {
    var _a;

    return ((_a = this.metadata.config) === null || _a === void 0 ? void 0 : _a.default_view) || 'table';
  }
};

/***/ }),

/***/ "50ab":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.metadataSchema = void 0;
var permissionAggregate = {
  type: 'object',
  properties: {
    aggregate: {
      type: 'object',
      properties: {
        count: {
          type: 'number'
        }
      }
    }
  }
};
exports.metadataSchema = {
  title: 'metadata schema',
  version: 0,
  description: 'Ha',
  type: 'object',
  properties: {
    full_name: {
      type: 'string',
      primary: true
    },
    table_name: {
      type: 'string'
    },
    table_schema: {
      type: 'string'
    },
    primaryKey: {
      type: 'object'
    },
    config: {
      type: ['object', 'null']
    },
    canSelect_aggregate: permissionAggregate,
    canInsert_aggregate: permissionAggregate,
    canUpdate_aggregate: permissionAggregate,
    relationships: {
      type: 'array',
      items: {
        type: 'object'
      }
    },
    columns: {
      type: 'array',
      items: {
        type: 'object'
      }
    }
  }
};

/***/ }),

/***/ "5fc8":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d86f");

__webpack_require__("8d0d");

__webpack_require__("cfce");

__webpack_require__("52f9");

__webpack_require__("c78b");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toJsonSchema = exports.metadataName = void 0;

var property_1 = __webpack_require__("98cd");

var metadataName = function metadataName(data) {
  return data.table_schema === 'public' ? "".concat(data.table_name) : "".concat(data.table_schema, "_").concat(data.table_name);
};

exports.metadataName = metadataName;
var postgresJsonSchemaFormatMapping = {
  timestamptz: 'date-time',
  time: 'time',
  timetz: 'time',
  date: 'date'
};

var propertyFormat = function propertyFormat(udtType) {
  return postgresJsonSchemaFormatMapping[udtType];
};

var toJsonSchema = function toJsonSchema(table) {
  var _a;

  var result = {
    type: 'object',
    title: ((_a = table.config) === null || _a === void 0 ? void 0 : _a.title) || exports.metadataName(table),
    description: '',
    version: 0,
    properties: {},
    required: [],
    indexes: []
  };
  var skipMappedForeignKeys = [];
  table.relationships.map(function (relationship) {
    var relName = relationship.rel_name;
    var mappingItem = relationship.mapping[0];
    var column = mappingItem.column;
    var refTable = mappingItem.remoteTable;
    var ref = exports.metadataName(refTable);
    var type = property_1.propertyJsonType(column);
    if (relationship.mapping.length !== 1) throw Error('object relationship with multi-column keys are not supported');

    if (relationship.rel_type === 'object') {
      relationship.mapping[0].remoteTable;
      result.properties[relName] = {
        type: type,
        ref: ref
      };
      skipMappedForeignKeys.push(column.column_name);
    } else if (relationship.rel_type === 'array') {
      result.properties[relName] = {
        type: 'array',
        ref: ref,
        items: {
          type: type
        }
      };
      result.properties["".concat(relName, "_aggregate")] = {
        type: 'object',
        properties: {
          aggregate: {
            type: 'object',
            properties: {
              max: {
                type: 'object',
                properties: {
                  updated_at: {
                    type: ['string', 'null']
                  }
                }
              }
            }
          }
        }
      };
    }
  });
  table.columns.map(function (column) {
    var _a;

    if (skipMappedForeignKeys.includes(column.column_name)) return;
    var name = column.column_name;
    var sqlType = column.udt_name;
    var type = property_1.propertyJsonType(column);

    if (!column.is_nullable) {
      (_a = result.required) === null || _a === void 0 ? void 0 : _a.push(name);
    }

    var property = {
      type: type
    };

    if (type === 'string' || type.includes('string')) {
      var format = propertyFormat(sqlType);

      if (format) {
        property.format = format;
      }
    }

    if (column.primaryKey) {
      ;
      property.primary = true;
    }

    result.properties[name] = property;
  });
  return result;
};

exports.toJsonSchema = toJsonSchema;

/***/ }),

/***/ "62a7":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d86f");

__webpack_require__("2d6d");

__webpack_require__("ef14");

__webpack_require__("cfce");

__webpack_require__("28eb");

__webpack_require__("972e");

__webpack_require__("7004");

__webpack_require__("868d");

__webpack_require__("52f9");

var _createForOfIteratorHelper = __webpack_require__("2b58");

var _slicedToArray = __webpack_require__("75d5");

var _toConsumableArray = __webpack_require__("4615");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pullModifier = exports.pullQueryBuilder = void 0;

var helpers_1 = __webpack_require__("87b5");

var pullQueryBuilder = function pullQueryBuilder(collection, batchSize) {
  var table = collection.metadata;
  var fields = table.columns.filter(function (column) {
    return column.canSelect.length;
  }).map(function (col) {
    return col.column_name;
  });
  var title = helpers_1.metadataName(table);
  var arrayRelationships = table.relationships.filter(function (rel) {
    return rel.rel_type === 'array';
  }).map(function (relationship) {
    var remoteColumns = relationship.mapping.map(function (item) {
      var _a;

      return (_a = item.column) === null || _a === void 0 ? void 0 : _a.column_name;
    });
    fields.push("".concat(relationship.rel_name, " { ").concat(remoteColumns.join(' '), " }"));
    fields.push("".concat(relationship.rel_name, "_aggregate { aggregate { max { updated_at } } }"));
    return relationship.rel_name;
  });
  var commonOrConditions = ['{ updated_at: { _gt: $updatedAt } }'];
  var initialOrConditions = [].concat(commonOrConditions, _toConsumableArray(arrayRelationships.map(function (rel) {
    return "{".concat(rel, ": { updated_at: { _gt: $updated_at_").concat(rel, " } } }");
  }))).join('\n');
  var updateOrConditions = [].concat(commonOrConditions, _toConsumableArray(arrayRelationships.map(function (rel) {
    return "{ _and: [\n    {".concat(rel, ": { updated_at: { _gt: $updated_at_").concat(rel, " } } }\n    {id: { _eq: $id } }\n  ]}");
  })));
  var commonVariableDeclarations = [['updatedAt', 'timestamptz']].concat(_toConsumableArray(arrayRelationships.map(function (rel) {
    return ["updated_at_".concat(rel), 'timestamptz'];
  })));
  var updateVariableDeclarations = [['id', 'uuid']].concat(_toConsumableArray(commonVariableDeclarations)).map(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        name = _ref2[0],
        type = _ref2[1];

    return "$".concat(name, ": ").concat(type);
  }).join(', ');
  var initialVariableDeclarations = commonVariableDeclarations.map(function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        name = _ref4[0],
        type = _ref4[1];

    return "$".concat(name, ": ").concat(type);
  }).join(', ');
  var initialQuery = "query query".concat(title, " (").concat(initialVariableDeclarations, "){\n      ").concat(title, " (\n            where: {\n                 _or: [").concat(initialOrConditions, "]\n              },\n            limit: ").concat(batchSize, ",\n            order_by: [ {updated_at: asc} ]\n      ){ ").concat(fields.join(' '), " }\n  }");
  var updateQuery = "query query".concat(title, " (").concat(updateVariableDeclarations, "){\n    ").concat(title, " (\n          where: {\n               _or: [").concat(updateOrConditions, "]\n            },\n          limit: ").concat(batchSize, ",\n          order_by: [ {updated_at: asc} ]\n    ){ ").concat(fields.join(' '), " }\n}");
  return function (doc) {
    return {
      query: doc ? updateQuery : initialQuery,
      variables: arrayRelationships.reduce(function (variables, rel) {
        var _a, _b, _c;

        return variables["updated_at_".concat(rel)] = ((_c = (_b = (_a = doc === null || doc === void 0 ? void 0 : doc["".concat(arrayRelationships, "_aggregate")]) === null || _a === void 0 ? void 0 : _a.aggregate) === null || _b === void 0 ? void 0 : _b.max) === null || _c === void 0 ? void 0 : _c.updated_at) || new Date(0).toISOString(), variables;
      }, {
        updatedAt: (doc === null || doc === void 0 ? void 0 : doc.updated_at) || new Date(0).toISOString(),
        id: doc === null || doc === void 0 ? void 0 : doc.id
      })
    };
  };
};

exports.pullQueryBuilder = pullQueryBuilder;

var pullModifier = function pullModifier(collection) {
  var table = collection.metadata;
  var cleansedRelationships = table.relationships.map(function (rel) {
    var _a;

    return {
      multiple: rel.rel_type === 'array',
      name: rel.rel_name,
      column: (_a = rel.mapping[0].column) === null || _a === void 0 ? void 0 : _a.column_name,
      remoteColumn: rel.mapping[0].remote_column_name
    };
  });
  return function (doc) {
    var _iterator = _createForOfIteratorHelper(cleansedRelationships),
        _step;

    try {
      var _loop = function _loop() {
        var _step$value = _step.value,
            name = _step$value.name,
            column = _step$value.column,
            multiple = _step$value.multiple;

        if (multiple) {
          doc[name] = doc[name].map(function (item) {
            return item[column];
          });
        } else {
          doc[name] = doc[column];
          delete doc[column];
        }
      };

      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        _loop();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    return doc;
  };
};

exports.pullModifier = pullModifier;

/***/ }),

/***/ "6cd0":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("2d6d");

__webpack_require__("28eb");

__webpack_require__("868d");

__webpack_require__("2007");

__webpack_require__("52f9");

__webpack_require__("f8a5");

__webpack_require__("ef1f");

__webpack_require__("26d3");

var _defineProperty = __webpack_require__("2843");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RxHasuraPlugin = void 0;

var rxjs_1 = __webpack_require__("2dc3");

var console_1 = __webpack_require__("e41d");

var replicator_1 = __webpack_require__("00bf");

var replicator_2 = __webpack_require__("95b5");

var schema_1 = __webpack_require__("50ab");

var jwt = new rxjs_1.BehaviorSubject(undefined);
var status = new rxjs_1.BehaviorSubject(false);
var hasura = new rxjs_1.BehaviorSubject({});

var hasuraCollections = function hasuraCollections(db) {
  return Object.keys(db.collections).filter(function (colName) {
    return db.collections[colName].options.metadata;
  }).reduce(function (aggr, curr) {
    return aggr[curr] = db.collections[curr], aggr;
  }, {});
};

exports.RxHasuraPlugin = {
  name: 'hasura-plugin',
  rxdb: true,
  prototypes: {
    RxDatabase: function RxDatabase(proto) {
      Object.defineProperty(proto, 'hasura$', {
        get: function get() {
          return hasura;
        }
      });
      Object.defineProperty(proto, 'status$', {
        get: function get() {
          return status;
        }
      });

      proto.setStatus = function (value, jwt) {
        this.status$.next(value);
        this.jwt$.next(jwt);
      };

      proto.setJwt = function (value) {
        this.jwt$.next(value);
      };

      Object.defineProperty(proto, 'jwt$', {
        get: function get() {
          return jwt;
        }
      });
      Object.defineProperty(proto, 'hasura', {
        get: function get() {
          return hasura.getValue();
        }
      });
    }
  },
  hooks: {
    createRxDatabase: function createRxDatabase(db) {
      return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                console_1.info("Add metadata to RxDatabase ".concat(db.name));
                _context.next = 3;
                return db.addCollections({
                  metadata: {
                    schema: schema_1.metadataSchema,
                    autoMigrate: true
                  }
                });

              case 3:
                _context.next = 5;
                return replicator_2.createMetadataReplicator(db.metadata);

              case 5:
                hasura.next(hasuraCollections(db));

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    },
    createRxCollection: function createRxCollection(collection) {
      return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!collection.options.metadata) {
                  _context2.next = 6;
                  break;
                }

                collection.metadata = collection.options.metadata;
                _context2.next = 4;
                return replicator_1.createContentReplicator(collection);

              case 4:
                console_1.info("create RxCollection ".concat(collection.name));
                hasura.next(Object.assign(Object.assign({}, hasuraCollections(collection.database)), _defineProperty({}, collection.name, collection)));

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
    }
  }
};

/***/ }),

/***/ "7d01":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

__webpack_require__("2aa5");

__webpack_require__("32f5");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.webSocketUrlToHttpUrl = exports.httpUrlToWebSockeUrl = void 0;

var httpUrlToWebSockeUrl = function httpUrlToWebSockeUrl(url) {
  return url.replace(/(http)(s)?:\/\//, 'ws$2://');
};

exports.httpUrlToWebSockeUrl = httpUrlToWebSockeUrl;

var webSocketUrlToHttpUrl = function webSocketUrlToHttpUrl(url) {
  return url.replace(/(ws)(s)?:\/\//, 'http$2://');
};

exports.webSocketUrlToHttpUrl = webSocketUrlToHttpUrl;

/***/ }),

/***/ "8744":
/***/ (function(module, exports) {


    var doc = {"kind":"Document","definitions":[{"kind":"FragmentDefinition","name":{"kind":"Name","value":"coreTable"},"typeCondition":{"kind":"NamedType","name":{"kind":"Name","value":"metadata_table"}},"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"table_name"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"table_schema"},"arguments":[],"directives":[]}]}},{"kind":"FragmentDefinition","name":{"kind":"Name","value":"column"},"typeCondition":{"kind":"NamedType","name":{"kind":"Name","value":"metadata_column_info"}},"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"column_name"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"udt_name"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"is_nullable"},"arguments":[],"directives":[]}]}},{"kind":"FragmentDefinition","name":{"kind":"Name","value":"table"},"typeCondition":{"kind":"NamedType","name":{"kind":"Name","value":"metadata_table"}},"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"coreTable"},"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"primaryKey"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"constraint_name"},"arguments":[],"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"config"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"title"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"description"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"icon"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"document_title"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"document_label"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"default_view"},"arguments":[],"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"canSelect_aggregate"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"aggregate"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"count"},"arguments":[],"directives":[]}]}}]}},{"kind":"Field","name":{"kind":"Name","value":"canInsert_aggregate"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"aggregate"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"count"},"arguments":[],"directives":[]}]}}]}},{"kind":"Field","name":{"kind":"Name","value":"canUpdate_aggregate"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"aggregate"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"count"},"arguments":[],"directives":[]}]}}]}},{"kind":"Field","name":{"kind":"Name","value":"relationships"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"rel_name"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"rel_type"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"mapping"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"column"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"column"},"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"remoteTable"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"coreTable"},"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"remote_column_name"},"arguments":[],"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"config"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"title"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"description"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"icon"},"arguments":[],"directives":[]}]}}]}},{"kind":"Field","name":{"kind":"Name","value":"columns"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"column"},"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"primaryKey"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"constraint_name"},"arguments":[],"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"canSelect"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"role_name"},"arguments":[],"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"canInsert"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"role_name"},"arguments":[],"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"canUpdate"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"role_name"},"arguments":[],"directives":[]}]}},{"kind":"Field","name":{"kind":"Name","value":"config"},"arguments":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"title"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"description"},"arguments":[],"directives":[]},{"kind":"Field","name":{"kind":"Name","value":"icon"},"arguments":[],"directives":[]}]}}]}}]}},{"kind":"OperationDefinition","operation":"query","name":{"kind":"Name","value":"metadata"},"variableDefinitions":[],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"metadata_table"},"arguments":[{"kind":"Argument","name":{"kind":"Name","value":"where"},"value":{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"_and"},"value":{"kind":"ListValue","values":[{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"table_schema"},"value":{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"_eq"},"value":{"kind":"StringValue","value":"public","block":false}}]}}]},{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"columns"},"value":{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"column_name"},"value":{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"_eq"},"value":{"kind":"StringValue","value":"updated_at","block":false}}]}}]}}]},{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"columns"},"value":{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"column_name"},"value":{"kind":"ObjectValue","fields":[{"kind":"ObjectField","name":{"kind":"Name","value":"_eq"},"value":{"kind":"StringValue","value":"id","block":false}}]}}]}}]}]}}]}}],"directives":[],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"table"},"directives":[]}]}}]}}],"loc":{"start":0,"end":1554}};
    doc.loc.source = {"body":"fragment coreTable on metadata_table {\n  table_name\n  table_schema\n}\n\nfragment column on metadata_column_info {\n  column_name\n  udt_name\n  is_nullable\n}\n\nfragment table on metadata_table {\n  ...coreTable\n  primaryKey {\n    constraint_name\n  }\n  config {\n    title\n    description\n    icon\n    document_title\n    document_label\n    default_view\n  }\n  canSelect_aggregate {\n    aggregate {\n      count\n    }\n  }\n  canInsert_aggregate {\n    aggregate {\n      count\n    }\n  }\n  canUpdate_aggregate {\n    aggregate {\n      count\n    }\n  }\n  relationships {\n    rel_name\n    rel_type\n    mapping {\n      column {\n        ...column\n      }\n      remoteTable {\n        ...coreTable\n      }\n      remote_column_name\n    }\n    config {\n      title\n      description\n      icon\n    }\n  }\n  columns {\n    ...column\n    primaryKey {\n      constraint_name\n    }\n    canSelect {\n      role_name\n    }\n    canInsert {\n      role_name\n    }\n    canUpdate {\n      role_name\n    }\n    config {\n      title\n      description\n      icon\n    }\n  }\n}\n\n# * Already filtered according to user permissions.\n# * > only maps the `public` schema\n# TODO move to permission: only allow users to see the `public` schema\n# * > need an `updated_at` column\n# ! > need an `id` column -> what if the primary key is not the id column?\nquery metadata {\n  metadata_table(\n    where: {\n      _and: [\n        { table_schema: { _eq: \"public\" } }\n        { columns: { column_name: { _eq: \"updated_at\" } } }\n        { columns: { column_name: { _eq: \"id\" } } }\n      ]\n    }\n  ) {\n    ...table\n  }\n}\n","name":"GraphQL request","locationOffset":{"line":1,"column":1}};
  

    var names = {};
    function unique(defs) {
      return defs.filter(
        function(def) {
          if (def.kind !== 'FragmentDefinition') return true;
          var name = def.name.value
          if (names[name]) {
            return false;
          } else {
            names[name] = true;
            return true;
          }
        }
      )
    }
  

    // Collect any fragment/type references from a node, adding them to the refs Set
    function collectFragmentReferences(node, refs) {
      if (node.kind === "FragmentSpread") {
        refs.add(node.name.value);
      } else if (node.kind === "VariableDefinition") {
        var type = node.type;
        if (type.kind === "NamedType") {
          refs.add(type.name.value);
        }
      }

      if (node.selectionSet) {
        node.selectionSet.selections.forEach(function(selection) {
          collectFragmentReferences(selection, refs);
        });
      }

      if (node.variableDefinitions) {
        node.variableDefinitions.forEach(function(def) {
          collectFragmentReferences(def, refs);
        });
      }

      if (node.definitions) {
        node.definitions.forEach(function(def) {
          collectFragmentReferences(def, refs);
        });
      }
    }

    var definitionRefs = {};
    (function extractReferences() {
      doc.definitions.forEach(function(def) {
        if (def.name) {
          var refs = new Set();
          collectFragmentReferences(def, refs);
          definitionRefs[def.name.value] = refs;
        }
      });
    })();

    function findOperation(doc, name) {
      for (var i = 0; i < doc.definitions.length; i++) {
        var element = doc.definitions[i];
        if (element.name && element.name.value == name) {
          return element;
        }
      }
    }

    function oneQuery(doc, operationName) {
      // Copy the DocumentNode, but clear out the definitions
      var newDoc = {
        kind: doc.kind,
        definitions: [findOperation(doc, operationName)]
      };
      if (doc.hasOwnProperty("loc")) {
        newDoc.loc = doc.loc;
      }

      // Now, for the operation we're running, find any fragments referenced by
      // it or the fragments it references
      var opRefs = definitionRefs[operationName] || new Set();
      var allRefs = new Set();
      var newRefs = new Set();

      // IE 11 doesn't support "new Set(iterable)", so we add the members of opRefs to newRefs one by one
      opRefs.forEach(function(refName) {
        newRefs.add(refName);
      });

      while (newRefs.size > 0) {
        var prevRefs = newRefs;
        newRefs = new Set();

        prevRefs.forEach(function(refName) {
          if (!allRefs.has(refName)) {
            allRefs.add(refName);
            var childRefs = definitionRefs[refName] || new Set();
            childRefs.forEach(function(childRef) {
              newRefs.add(childRef);
            });
          }
        });
      }

      allRefs.forEach(function(refName) {
        var op = findOperation(doc, refName);
        if (op) {
          newDoc.definitions.push(op);
        }
      });

      return newDoc;
    }

    module.exports = doc;
    
        module.exports["metadata"] = oneQuery(doc, "metadata");
        


/***/ }),

/***/ "87b5":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("8f84");

__webpack_require__("52f9");

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __exportStar = this && this.__exportStar || function (m, exports) {
  for (var p in m) {
    if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  }
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

__exportStar(__webpack_require__("98cd"), exports);

__exportStar(__webpack_require__("13cd"), exports);

__exportStar(__webpack_require__("5fc8"), exports);

__exportStar(__webpack_require__("a090"), exports);

/***/ }),

/***/ "95b5":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("2007");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

var _defineProperty = __webpack_require__("2843");

__webpack_require__("df26");

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createMetadataReplicator = void 0;

var printer_1 = __webpack_require__("103a");

var console_1 = __webpack_require__("e41d");

var collection_creator_1 = __webpack_require__("042f");

var helpers_1 = __webpack_require__("87b5");

var metadata_graphql_1 = __importDefault(__webpack_require__("8744"));

var query = printer_1.print(metadata_graphql_1["default"]);
var noopQuery = '{metadata_table(where:{_and:[{table_schema: {_eq: "noop"}},{table_schema: {_neq: "noop"}}]}) {table_name}}';

var createMetadataReplicatorOptions = function createMetadataReplicatorOptions(db) {
  var token = db.jwt$.getValue();
  var headers = token ? {
    Authorization: "Bearer ".concat(token)
  } : {};
  return {
    url: db.options.url,
    headers: headers,
    pull: {
      queryBuilder: function queryBuilder(doc) {
        return {
          query: doc ? noopQuery : query,
          variables: {}
        };
      },
      modifier: function modifier(doc) {
        return Object.assign(Object.assign({}, doc), {
          full_name: helpers_1.metadataName(doc)
        });
      }
    },
    live: true,
    liveInterval: 1000 * 60 * 10,
    deletedFlag: 'deleted'
  };
};

var createMetadataReplicator = function createMetadataReplicator(metadata) {
  return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
    var db, state, metaSubscription, jwtSubscription, errorSubscription, start, stop;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            db = metadata.database;

            start = function start() {
              return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        state = metadata.syncGraphQL(createMetadataReplicatorOptions(db));
                        metaSubscription = metadata.$.subscribe(function (event) {
                          return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                            return regeneratorRuntime.wrap(function _callee$(_context) {
                              while (1) {
                                switch (_context.prev = _context.next) {
                                  case 0:
                                    if (!(event.operation === 'INSERT' || event.operation === 'UPDATE')) {
                                      _context.next = 3;
                                      break;
                                    }

                                    _context.next = 3;
                                    return metadata.database.addCollections(_defineProperty({}, event.documentId, collection_creator_1.contentsCollectionCreator(event.documentData)));

                                  case 3:
                                  case "end":
                                    return _context.stop();
                                }
                              }
                            }, _callee);
                          }));
                        });
                        errorSubscription = state.error$.subscribe(function (data) {
                          console_1.warn('metadata sync error', data);
                        });
                        jwtSubscription = db.jwt$.subscribe(function (token) {
                          console_1.debug('Replicator (metadata): set token');
                          var headers = (state === null || state === void 0 ? void 0 : state.headers) || {};
                          if (token) headers.Authorization = "Bearer ".concat(token);else delete headers.Authorization;
                          state === null || state === void 0 ? void 0 : state.setHeaders(headers);
                        });
                        _context2.next = 6;
                        return state.awaitInitialReplication();

                      case 6:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));
            };

            stop = function stop() {
              return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return state === null || state === void 0 ? void 0 : state.cancel();

                      case 2:
                        metaSubscription === null || metaSubscription === void 0 ? void 0 : metaSubscription.unsubscribe();
                        jwtSubscription === null || jwtSubscription === void 0 ? void 0 : jwtSubscription.unsubscribe();
                        errorSubscription === null || errorSubscription === void 0 ? void 0 : errorSubscription.unsubscribe();

                      case 5:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));
            };

            db.status$.subscribe(function (status) {
              return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        if (!status) {
                          _context4.next = 5;
                          break;
                        }

                        _context4.next = 3;
                        return start();

                      case 3:
                        _context4.next = 7;
                        break;

                      case 5:
                        _context4.next = 7;
                        return stop();

                      case 7:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              }));
            });
            metadata.replicator = {
              start: start,
              stop: stop
            };

          case 5:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
};

exports.createMetadataReplicator = createMetadataReplicator;

/***/ }),

/***/ "98cd":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("2d6d");

__webpack_require__("8d0d");

__webpack_require__("a650");

__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.castValue = exports.isTextType = exports.propertyType = exports.propertyJsonType = void 0;
var postgresJsonSchemaTypeMapping = {
  uuid: 'string',
  bool: 'boolean',
  timestamp: 'string',
  timestamptz: 'string',
  date: 'string',
  timetz: 'string',
  time: 'string',
  text: 'string',
  citext: 'string',
  varchar: 'string',
  jsonb: 'object',
  numeric: 'number',
  int4: 'integer',
  int8: 'integer',
  float4: 'number'
};

var propertyJsonType = function propertyJsonType(columnInfo) {
  var udtType = columnInfo.udt_name;
  var isNullable = columnInfo.is_nullable === 'YES';
  if (!postgresJsonSchemaTypeMapping[udtType]) throw Error("PostgresSQL type \"".concat(udtType, "\" is not mapped to JSON Schema"));
  var result = postgresJsonSchemaTypeMapping[udtType] || udtType;
  return isNullable ? [result, 'null'] : result;
};

exports.propertyJsonType = propertyJsonType;

var propertyType = function propertyType(property) {
  if (!property.type) throw Error("No type in prop: ".concat(JSON.stringify(property)));
  var type;

  if (Array.isArray(property.type)) {
    var res = property.type.filter(function (v) {
      return v !== 'null';
    });
    if (res.length === 1) type = res[0];else throw Error("Composite types are not allowed: ".concat(JSON.stringify(property)));
  } else {
    type = property.type;
  }

  if (property.ref) {
    if (type === 'array') return 'collection';else return 'document';
  }

  return property.format || type;
};

exports.propertyType = propertyType;

var isTextType = function isTextType(type) {
  return ['string', 'date', 'date-time', 'time', 'email', 'document', 'collection'].includes(type);
};

exports.isTextType = isTextType;

var castValue = function castValue(document, propertyName, value) {
  var type = exports.propertyType(document.collection.schema.jsonSchema.properties[propertyName]);
  return typeof value === 'boolean' || exports.isTextType(type) ? value : JSON.parse(value);
};

exports.castValue = castValue;

/***/ }),

/***/ "9c85":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("8f84");

__webpack_require__("52f9");

__webpack_require__("ef1f");

__webpack_require__("26d3");

__webpack_require__("df26");

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __exportStar = this && this.__exportStar || function (m, exports) {
  for (var p in m) {
    if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  }
};

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRxHasura = exports.RxHasuraPlugin = void 0;

var rxdb_1 = __webpack_require__("a078");

var ajv_validate_1 = __webpack_require__("53d9");

var replication_graphql_1 = __webpack_require__("1250");

var plugin_1 = __webpack_require__("6cd0");

var plugin_2 = __webpack_require__("6cd0");

Object.defineProperty(exports, "RxHasuraPlugin", {
  enumerable: true,
  get: function get() {
    return plugin_2.RxHasuraPlugin;
  }
});

__exportStar(__webpack_require__("87b5"), exports);

__exportStar(__webpack_require__("30f8"), exports);

var createRxHasura = function createRxHasura(name, url) {
  return __awaiter(void 0, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var settings, db;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            settings = {
              name: name,
              multiInstance: false,
              eventReduce: true,
              options: {
                url: url
              },
              adapter:  false ? undefined : 'idb'
            };
            rxdb_1.addRxPlugin(replication_graphql_1.RxDBReplicationGraphQLPlugin);
            rxdb_1.addRxPlugin(ajv_validate_1.RxDBAjvValidatePlugin);
            rxdb_1.addRxPlugin(plugin_1.RxHasuraPlugin);

            if (false) {} else {
              rxdb_1.addRxPlugin(__webpack_require__("e3be"));
            }

            _context.next = 7;
            return rxdb_1.createRxDatabase(settings);

          case 7:
            db = _context.sent;

            if (false) {}

            return _context.abrupt("return", db);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
};

exports.createRxHasura = createRxHasura;

/***/ }),

/***/ "a090":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.documentLabel = void 0;

var handlebars_1 = __importDefault(__webpack_require__("c737"));

var documentLabel = function documentLabel(doc, collection) {
  var _a;

  var template = ((_a = collection.metadata.config) === null || _a === void 0 ? void 0 : _a.document_label) || "{{".concat(collection.schema.primaryPath, "}}");
  var compiledTemplate = handlebars_1["default"].compile(template, {
    noEscape: true
  });
  return compiledTemplate(doc, {
    allowProtoPropertiesByDefault: true
  }) || null;
};

exports.documentLabel = documentLabel;

/***/ }),

/***/ "c11e":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("d6de");

__webpack_require__("d86f");

__webpack_require__("2d6d");

__webpack_require__("beb4");

__webpack_require__("cfce");

__webpack_require__("28eb");

__webpack_require__("868d");

__webpack_require__("2007");

__webpack_require__("52f9");

var _createForOfIteratorHelper = __webpack_require__("2b58");

var _toConsumableArray = __webpack_require__("4615");

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pushModifier = exports.pushQueryBuilder = void 0;

var stringify_object_1 = __importDefault(__webpack_require__("a4f1"));

var console_1 = __webpack_require__("e41d");

var helpers_1 = __webpack_require__("87b5");

var isNewDocument = function isNewDocument(doc) {
  return !doc.updated_at;
};

var pushQueryBuilder = function pushQueryBuilder(collection) {
  var table = collection.metadata;
  var title = helpers_1.metadataName(table);
  return function (_a) {
    var _isNew = _a._isNew,
        doc = __rest(_a, ["_isNew"]);

    console_1.debug('push query builder in', doc);

    var id = doc.id,
        updateDoc = __rest(doc, ["id"]);

    var query = _isNew ? "mutation { insert_".concat(title, "_one(object:").concat(stringify_object_1["default"](doc, {
      singleQuotes: false
    }), ") { id } }") : "mutation { update_".concat(title, "(where: { id: { _eq: \"").concat(id, "\" } }, _set: ").concat(stringify_object_1["default"](updateDoc, {
      singleQuotes: false
    }), ") { returning { id } } }");
    console_1.debug('push query builder:', {
      query: query
    });
    return {
      query: query,
      variables: {}
    };
  };
};

exports.pushQueryBuilder = pushQueryBuilder;

var pushModifier = function pushModifier(collection) {
  var table = collection.metadata;
  var objectRelationships = table.relationships.filter(function (_ref) {
    var rel_type = _ref.rel_type;
    return rel_type === 'object';
  }).map(function (rel) {
    var _a;

    return {
      name: rel.rel_name,
      column: (_a = rel.mapping[0].column) === null || _a === void 0 ? void 0 : _a.column_name
    };
  });
  var excludeFields = ['deleted'].concat(_toConsumableArray(table.relationships.filter(function (_ref2) {
    var rel_type = _ref2.rel_type;
    return rel_type === 'array';
  }).reduce(function (aggr, _ref3) {
    var rel_name = _ref3.rel_name;
    return aggr.push(rel_name, "".concat(rel_name, "_aggregate")), aggr;
  }, [])));
  var forbiddenInsertColumns = table.columns.filter(function (column) {
    return !column.canInsert.length;
  }).map(function (column) {
    return column.column_name;
  });
  var forbiddenUpdateColumns = table.columns.filter(function (column) {
    return !column.canUpdate.length;
  }).map(function (column) {
    return column.column_name;
  });
  return function (doc) {
    console_1.debug('pushModifier: in:', doc);

    var _isNew = isNewDocument(doc);

    var id = doc.id;

    var _iterator = _createForOfIteratorHelper(objectRelationships),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _step$value = _step.value,
            name = _step$value.name,
            column = _step$value.column;
        doc[column] = doc[name];
        delete doc[name];
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    var excluded = [].concat(_toConsumableArray(excludeFields), _toConsumableArray(isNewDocument(doc) ? forbiddenInsertColumns : forbiddenUpdateColumns));

    var _iterator2 = _createForOfIteratorHelper(excluded),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var field = _step2.value;
        delete doc[field];
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    console_1.debug('pushModifier: out', Object.assign({}, doc));
    return Object.assign(Object.assign({
      _isNew: _isNew
    }, doc), {
      id: id
    });
  };
};

exports.pushModifier = pushModifier;

/***/ }),

/***/ "e41d":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("52f9");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.errorDir = exports.error = exports.warn = exports.info = exports.debug = void 0;
var LOG_LEVEL;

(function (LOG_LEVEL) {
  LOG_LEVEL[LOG_LEVEL["MUTE"] = 0] = "MUTE";
  LOG_LEVEL[LOG_LEVEL["ERROR"] = 1] = "ERROR";
  LOG_LEVEL[LOG_LEVEL["WARN"] = 2] = "WARN";
  LOG_LEVEL[LOG_LEVEL["INFO"] = 3] = "INFO";
  LOG_LEVEL[LOG_LEVEL["DEBUG"] = 4] = "DEBUG";
})(LOG_LEVEL || (LOG_LEVEL = {}));

var VERBOSE_LEVEL =  false ? undefined : LOG_LEVEL.ERROR;

var debug = function debug() {
  var _console;

  return VERBOSE_LEVEL >= LOG_LEVEL.DEBUG && (_console = console).log.apply(_console, arguments);
};

exports.debug = debug;

var info = function info() {
  var _console2;

  return VERBOSE_LEVEL >= LOG_LEVEL.INFO && (_console2 = console).log.apply(_console2, arguments);
};

exports.info = info;

var warn = function warn() {
  var _console3;

  return VERBOSE_LEVEL >= LOG_LEVEL.WARN && (_console3 = console).warn.apply(_console3, arguments);
};

exports.warn = warn;

var error = function error() {
  var _console4;

  return VERBOSE_LEVEL >= LOG_LEVEL.ERROR && (_console4 = console).warn.apply(_console4, arguments);
};

exports.error = error;

var errorDir = function errorDir() {
  var _console5;

  return VERBOSE_LEVEL >= LOG_LEVEL.ERROR && (_console5 = console).dir.apply(_console5, arguments);
};

exports.errorDir = errorDir;

/***/ })

}]);
//# sourceMappingURL=vue-rxdb-hasura.umd.vue-rxdb-hasura.umd~493df0b3.js.map